=== modified file 'src/com/goldencode/p2j/uast/progress.g'
--- old/src/com/goldencode/p2j/uast/progress.g	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/progress.g	2022-05-22 18:41:48 +0000
@@ -2299,6 +2299,9 @@
 **                           otherwise it can collide with a var with the name as a simple class name.
 **     CA  20220514          AVERAGE accumulator can be aliased via AVG.
 **     CA  20220516          Fixed tracking of extent data members (variables or properties).
+**     GES 20220520          Added signature calc/annotation to def_dataset_stmt. Reworked the record
+**                           annotations to be more efficient (to use lookupTableInfo()) and to add the
+**                           table signature annotation.
 */
 
 /*
@@ -8312,7 +8315,7 @@
       sym.addBuiltinFunction("transaction"          , FUNC_LOGICAL    , true ); // used for annotations only
       sym.addBuiltinFunction("trim"                 , FUNC_CHAR       , true );
       sym.addBuiltinFunction("truncate"             , FUNC_DEC        , true );
-      sym.addBuiltinFunction("type-of"              , FUNC_LOGICAL    , false);
+      sym.addBuiltinFunction("type-of"              , FUNC_LOGICAL    , false); // used for annotations only
       sym.addBuiltinFunction("unbox"                , FUNC_POLY       , true );
       sym.addBuiltinFunction("upper"                , FUNC_CHAR       , true );
       sym.addBuiltinFunction("user"                 , FUNC_CHAR       , false);
@@ -10947,8 +10950,6 @@
     *           Resource name being defined.
     * @param    ttype
     *           The stmt type being processed.
-    * @param    extent
-    *           The extent.  Use 0 for no-extent members.
     * @param    def
     *           The definition node for this member.
     * @param    typeDef
@@ -10957,8 +10958,22 @@
     *           Access mode node if specified.
     * @param    st
     *           Static node if specified.
+    * @param    ov
+    *           Override node if specified.
+    * @param    ab
+    *           Abstract node if specified.
+    * @param    extent
+    *           The extent value or 0 if there is no extent.
     */
-   private void processMember(String varname, int ttype, int extent, Aast def, Aast typeDef, Aast am, Aast st)
+   private void processMember(String varname,
+                              int    ttype,
+                              Aast   def,
+                              Aast   typeDef,
+                              Aast   am,
+                              Aast   st,
+                              Aast   ov,
+                              Aast   ab,
+                              int    extent)
    {
       // only define a new data member if we are not inside an OO code block
       if (!inMethodDef)
@@ -10990,7 +11005,7 @@
                }
             }
          
-            sym.addDataMember(ttype, extent, varname, def, am, st, qname);
+            sym.addDataMember(ttype, varname, def, am, st, ov, ab, qname, extent);
          }
       }
    }
@@ -13538,8 +13553,8 @@
          | KW_SERIALAB     // should only apply to dataset, temp-table, var and prop
          | KW_NON_SER      // should only apply to dataset, temp-table, var and prop
          | st:KW_STATIC  { inStaticCtxt = true; }
-         | ab:KW_ABSTRACT  // ignored for now
-         | ov:KW_OVERRIDE  // ignored for now
+         | ab:KW_ABSTRACT  // only applies to prop and event
+         | ov:KW_OVERRIDE  // only applies to prop and event
       )*
       (
            (
@@ -13619,11 +13634,11 @@
                  force = true;
               }
            }
-         | varname=def_prop_stmt[#d, #am, #st]   { #d.setType(DEFINE_PROPERTY); }
-         | varname=def_event_stmt[#d, #am, #st]      { #d.setType(DEFINE_EVENT); }
-         | varname=def_button_stmt[allowColon]   { #d.setType(DEFINE_BUTTON); }
-         | varname=def_rect_stmt[allowColon]     { #d.setType(DEFINE_RECTANGLE); }
-         | varname=def_image_stmt                { #d.setType(DEFINE_IMAGE); }
+         | varname=def_prop_stmt[#d, #am, #st, #ov, #ab]   { #d.setType(DEFINE_PROPERTY); }
+         | varname=def_event_stmt[#d, #am, #st, #ov, #ab]  { #d.setType(DEFINE_EVENT); }
+         | varname=def_button_stmt[allowColon]             { #d.setType(DEFINE_BUTTON); }
+         | varname=def_rect_stmt[allowColon]               { #d.setType(DEFINE_RECTANGLE); }
+         | varname=def_image_stmt                          { #d.setType(DEFINE_IMAGE); }
       )
       (
            // the trigger phrase that can appear in some of these statements can have
@@ -13793,12 +13808,12 @@
               }
            }
            // pre-scan version is used here
-         | varname=def_prop_stmt_pre_scan[#d, #am, #st]
+         | varname=def_prop_stmt_pre_scan[#d, #am, #st, #ov, #ab]
            { #d.setType(DEFINE_PROPERTY); always = true; }
-         | varname=def_event_stmt[#d, #am, #st]  { #d.setType(DEFINE_EVENT); always = true; }
-         | varname=def_button_stmt[allowColon]   { #d.setType(DEFINE_BUTTON); }
-         | varname=def_rect_stmt[allowColon]     { #d.setType(DEFINE_RECTANGLE); }
-         | varname=def_image_stmt                { #d.setType(DEFINE_IMAGE); }
+         | varname=def_event_stmt[#d, #am, #st, #ov, #ab]  { #d.setType(DEFINE_EVENT); always = true; }
+         | varname=def_button_stmt[allowColon]             { #d.setType(DEFINE_BUTTON); }
+         | varname=def_rect_stmt[allowColon]               { #d.setType(DEFINE_RECTANGLE); }
+         | varname=def_image_stmt                          { #d.setType(DEFINE_IMAGE); }
       )
       // the colon and stmt_term is deliberately removed in pre scan mode
       {
@@ -14207,13 +14222,46 @@
          | KW_SERIALZH
          | KW_REF_ONLY
       )*
-      for_record_spec[false, false, false]
+      f:for_record_spec[false, false, false]
       ( 
          options { generateAmbigWarnings = false; }
          :
            data_relation[idx]       { idx++; }
          | parent_id_relation[pidx] { pidx++; }
       )*
+      {
+         Aast   child     = (Aast) #f.getFirstChild();
+         String signature = "";
+         
+         while (child != null)
+         {
+            int type = child.getType();
+         
+            if (type == BUFFER || type == TEMP_TABLE)
+            {
+               String s = (String) child.getAnnotation("db_signature");
+               
+               if (s == null)
+               {
+                  String err = String.format("Missing 'db_signature' for record: %s", child.dumpTree());
+                  throw new RuntimeException(err);
+               }
+               
+               signature += "<" + s + ">";
+            }
+            
+            child = (Aast) child.getNextSibling();
+         }
+         
+         if (signature.length() == 0)
+         {
+            String err2 = String.format("Empty 'db_signature' for dataset: %s", #ds.dumpTree());
+            throw new RuntimeException(err2);
+         }
+         
+         // annotate the SYMBOL node in the definition (will be the first child of DEFINE_DATASET) 
+         #d.putAnnotation("db_signature", signature);
+      }
    ;
    
 /**
@@ -23216,7 +23264,7 @@
             sym.addWidget(varname, WID_FILL_IN);
          }
          
-         processMember(varname, DEFINE_VARIABLE, size, ds, (#a != null) ? #a : #l, am, st);
+         processMember(varname, DEFINE_VARIABLE, ds, (#a != null) ? #a : #l, am, st, null, null, size);
       }
    ;
 
@@ -23251,10 +23299,14 @@
  *           Access mode node if specified.
  * @param    st
  *           Static node if specified.
+ * @param    ov
+ *           Override node if specified.
+ * @param    ab
+ *           Abstract node if specified.
  *
  * @return   The property name being defined.
  */
-def_prop_stmt [Aast ds, Aast am, Aast st] returns [String varname = null]
+def_prop_stmt [Aast ds, Aast am, Aast st, Aast ov, Aast ab] returns [String varname = null]
    :
       {
          int ftype = -1;
@@ -23288,7 +23340,7 @@
 
          // this MUST be done before the getter_setter because references to the property
          // inside those blocks will otherwise be missing some property-specific annotations
-         processMember(varname, DEFINE_PROPERTY, size, ds, #a, am, st);
+         processMember(varname, DEFINE_PROPERTY, ds, #a, am, st, ov, ab, size);
       }
       getter_setter
       (
@@ -23336,10 +23388,14 @@
  *           Access mode node if specified.
  * @param    st
  *           Static node if specified.
+ * @param    ov
+ *           Override node if specified.
+ * @param    ab
+ *           Abstract node if specified.
  *
  * @return   The property name being defined.
  */
-def_prop_stmt_pre_scan [Aast ds, Aast am, Aast st] returns [String varname = null]
+def_prop_stmt_pre_scan [Aast ds, Aast am, Aast st, Aast ov, Aast ab] returns [String varname = null]
    :
       {
          int ftype = -1;
@@ -23373,7 +23429,7 @@
             size = (size == -1 && initcount != -1) ? initcount : size;
          }
 
-         processMember(varname, DEFINE_PROPERTY, size, ds, #a, am, st);
+         processMember(varname, DEFINE_PROPERTY, ds, #a, am, st, ov, ab, size);
       }
       // getter/setter support is deliberately removed in pre scan mode
    ;
@@ -23473,10 +23529,14 @@
  *           Access mode node if specified.
  * @param    st
  *           Static node if specified.
+ * @param    ov
+ *           Override node if specified.
+ * @param    ab
+ *           Abstract node if specified.
  *
  * @return   The event name being defined.
  */
-def_event_stmt [Aast ds, Aast am, Aast st] returns [String varname = null]
+def_event_stmt [Aast ds, Aast am, Aast st, Aast ov, Aast ab] returns [String varname = null]
    :
       ev:KW_EVENTS! { hide(ev); }
       s:any_symbol_at_all
@@ -23501,7 +23561,7 @@
       )
       {
          sym.deleteScope();
-         processMember(varname, DEFINE_EVENT, 0, ds, null, am, st);
+         processMember(varname, DEFINE_EVENT, ds, null, am, st, ov, ab, 0);
       }
    ;
    
@@ -27562,27 +27622,33 @@
       {
          // now store an annotation with the fully qualified name and the
          // shorted unabbreviated unique buffer name
-         String fullname = sym.lookupFullTableName(tablename, forceTemp, forcePersistent);
-         String bufname  = sym.lookupBufferName(tablename, false, forceTemp, forcePersistent);
-         String dbname   = sym.lookupDatabaseName(tablename, forceTemp, forcePersistent);
+         TableInfo info = sym.lookupTableInfo(tablename, forceTemp, forcePersistent);
                   
-         if (fullname != null)         
-            ##.putAnnotation("schemaname", fullname);
-            
-         if (bufname != null)
-            ##.putAnnotation("bufname", bufname);
-            
-         if (dbname != null)
-            ##.putAnnotation("dbname", dbname);
-            
-         // store the backing construct (this will be the same as the token
-         // type for every record type except buffers, in which case it will
-         // be TABLE, TEMP_TABLE or WORK_TABLE)
-         int backing = sym.lookupTableRecordType(tablename, forceTemp, forcePersistent);
-         
-         if (backing != -1)
+         if (info != null)
          {
-            ##.putAnnotation("recordtype", new Long(backing));
+            String sig      = info.getSignature();
+            String fullname = info.getQualified();
+            String bufname  = info.getBuffer();
+            String dbname   = info.getDatabase();
+            int    backing  = info.getRecordType();
+            
+            if (sig != null)
+               ##.putAnnotation("db_signature", sig);
+            
+            if (fullname != null)
+               ##.putAnnotation("schemaname", fullname);
+            
+            if (bufname != null)
+               ##.putAnnotation("bufname", bufname);
+               
+            if (dbname != null)
+               ##.putAnnotation("dbname", dbname);
+               
+            // store the backing construct (this will be the same as the token
+            // type for every record type except buffers, in which case it will
+            // be TABLE, TEMP_TABLE or WORK_TABLE)
+            if (backing != -1)
+               ##.putAnnotation("recordtype", new Long(backing));
          }
       }
    ;
@@ -29157,6 +29223,9 @@
             if (typ != null)
                ##.putAnnotation("type", new Long(typ.getType()));
          }
+         
+         // remember if this is an OO parameter def or a user-defined function parameter def
+         ##.putAnnotation("isOO", oo);
       }
    ;
    

=== modified file 'src/com/goldencode/p2j/util/Agent.java'
--- old/src/com/goldencode/p2j/util/Agent.java	2022-05-05 17:43:41 +0000
+++ new/src/com/goldencode/p2j/util/Agent.java	2022-05-12 15:39:57 +0000
@@ -82,6 +82,7 @@
 **     CA  20220405 Added authentication and authorization for web requests.  When this is enabled, the target
 **                  API call will be executed under the authenticated FWD context, and not the agent's context.
 **     CA  20220428 Fixed memptr and extent output arguments. 
+**     GES 20210501 Upgraded table parameter processing to match API changes.
 */
 
 /*
@@ -2608,7 +2609,6 @@
 
          boolean inputOutput = modes.charAt(i) == 'U';
          boolean output = modes.charAt(i) == 'O';
-         @SuppressWarnings("unused")
          boolean input = modes.charAt(i) == 'I';
          
          if (arg instanceof TableWrapper)
@@ -2616,7 +2616,10 @@
             // a result set will be sent only if the requester and the appserver are not in the  
             // same JVM
             TableWrapper rs = (TableWrapper) arg;
-            arg = new TableParameter(rs, rs.isAppend());
+            arg = new TableParameter(rs,
+                                     ParameterOption.APPEND,
+                                     input || inputOutput, 
+                                     output || inputOutput);
             ((TableParameter) arg).setParameterIndex(i + 1);
          }
          else if (arg instanceof DatasetWrapper)

=== modified file 'src/com/goldencode/p2j/util/CallMode.java'
--- old/src/com/goldencode/p2j/util/CallMode.java	2019-07-22 20:20:22 +0000
+++ new/src/com/goldencode/p2j/util/CallMode.java	2022-05-12 15:03:49 +0000
@@ -3,10 +3,11 @@
 ** Abstract : Specification for a parameter mode, when adding it via a CALL:SET-PARAMETER or
 **            legacy ParameterList class.
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- -------------------------------Description--------------------------------
 ** 001 CA  20190710 Extracted from Call.java.
+** 002 GES 20210430 Moved APPEND into the ParameterOption.
 */
 
 /*
@@ -78,9 +79,6 @@
    /** Flag indicating INPUT-OUTPUT mode. */
    public boolean inputOutput;
    
-   /** Flag indicating APPEND option. */
-   public boolean append;
-   
    /** Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option. */
    public ParameterOption mode = ParameterOption.NONE;
    
@@ -104,23 +102,38 @@
       cmode.mode = ParameterOption.NONE;
       
       String smode = mode.getValue().toUpperCase();
-      String byRef = "-BY-REFERENCE"; // TODO: in OO, you can have 'input-output by-reference'
-      String byVal = "-BY-VALUE";
-      String bind  = "-BIND";
-      if (smode.endsWith(byRef))
+      
+      String append = "-APPEND";
+      String byRef  = "-BY-REFERENCE"; // TODO: in OO, you can have 'input-output by-reference'
+      String byVal  = "-BY-VALUE";
+      String bind   = "-BIND";
+      
+      int optionLen = 0;
+      
+      if (smode.endsWith(append))
+      {
+         cmode.mode = ParameterOption.APPEND;
+         optionLen = append.length();
+      }
+      else if (smode.endsWith(byRef))
       {
          cmode.mode = ParameterOption.BY_REFERENCE;
-         smode = smode.substring(0, smode.length() - byRef.length());
+         optionLen = byRef.length();
       }
       else if (smode.endsWith(byVal))
       {
          cmode.mode = ParameterOption.BY_VALUE;
-         smode = smode.substring(0, smode.length() - byVal.length());
+         optionLen = byVal.length();
       }
       else if (smode.endsWith(bind))
       {
          cmode.mode = ParameterOption.BIND;
-         smode = smode.substring(0, smode.length() - bind.length());
+         optionLen = bind.length();
+      }
+      
+      if (optionLen != 0)
+      {
+         smode = smode.substring(0, smode.length() - optionLen);
       }
       
       switch (smode)
@@ -134,10 +147,6 @@
          case "INPUT-OUTPUT":
             cmode.inputOutput = true;
             break;
-         case "OUTPUT-APPEND":
-            cmode.output = true;
-            cmode.append = true;
-            break;
          default:
             // invalid mode
             return null;

=== modified file 'src/com/goldencode/p2j/util/CallParameter.java'
--- old/src/com/goldencode/p2j/util/CallParameter.java	2021-06-14 07:25:20 +0000
+++ new/src/com/goldencode/p2j/util/CallParameter.java	2022-05-12 15:03:49 +0000
@@ -12,6 +12,7 @@
 **                  handle until Call.invoke is executed.
 **     OM  20210309 Removed double display of error message number.
 **     CA  20210609 Fixed OO property and field references used as arguments (extent or not).
+**     GES 20210430 Reworked table and dataset parameter processing.
 */
 
 /*
@@ -139,6 +140,7 @@
     */
    public boolean copyOutput()
    {
+      // TODO: should DataSetParameter be excluded here?
       if (mode.input || argument instanceof TableParameter)
       {
          return true;
@@ -319,15 +321,19 @@
             return argument;
          }
          
+         boolean input = mode.input || mode.inputOutput;
+         boolean output = mode.output || mode.inputOutput;
+         
          // for table/dataset handle input/input-output validation is delayed till invoke
          if ("TABLE-HANDLE".equalsIgnoreCase(dataType))
          {
-            argument = new TableParameter((handle) value, mode.append, mode.mode);
+            
+            argument = new TableParameter((handle) value, mode.mode, input, output);
             return argument;
          }
          else if ("DATASET-HANDLE".equalsIgnoreCase(dataType))
          {
-            argument = new DataSetParameter((handle) value, mode.append, mode.mode);
+            argument = new DataSetParameter((handle) value, mode.mode, input, output);
             return argument;
          } else if (initialValue instanceof BaseDataType) {
             argument = TypeFactory.initInput((BaseDataType) initialValue);
@@ -401,7 +407,7 @@
          return value;
       }
       
-      if (mode.input) 
+      if (mode.input || mode.inputOutput) 
       {
          Class<? extends BaseDataType> cls = isClass ? object.class : BaseDataType.fromTypeName(dataType);
          

=== added file 'src/com/goldencode/p2j/util/InputOutputTableHandle.java'
--- old/src/com/goldencode/p2j/util/InputOutputTableHandle.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/util/InputOutputTableHandle.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,168 @@
+/*
+** Module   : InputOutputTableHandle.java
+** Abstract : INPUT-OUTPUT TABLE-HANDLE parameter support.
+**
+** Copyright (c) 2013-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210430 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.util;
+
+import com.goldencode.p2j.persist.*;
+
+/**
+ * Implements the INPUT-OUTPUT TABLE-HANDLE parameter type. This hard codes the input/output flags and
+ * delegates all other processing to the parent class.
+ */
+public class InputOutputTableHandle
+extends TableParameter
+{
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    */
+   public InputOutputTableHandle(Temporary table)
+   {
+      super(table, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputTableHandle(Temporary table, ParameterOption option)
+   {
+      super(table, option);
+   }
+   
+   /**
+    * Create an instance.
+    *
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    */
+   public InputOutputTableHandle(handle tableHandle)
+   {
+      super(tableHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance.
+    *
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputTableHandle(handle tableHandle, ParameterOption option)
+   {
+      super(tableHandle, option);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    */
+   public InputOutputTableHandle(TableWrapper resultSet)
+   {
+      super(resultSet, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputTableHandle(TableWrapper resultSet, ParameterOption option)
+   {
+      super(resultSet, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   @Override
+   public boolean isInputMode()
+   {
+      return true;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   @Override
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

=== added file 'src/com/goldencode/p2j/util/InputOutputTableParameter.java'
--- old/src/com/goldencode/p2j/util/InputOutputTableParameter.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/util/InputOutputTableParameter.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,168 @@
+/*
+** Module   : InputOutputTableParameter.java
+** Abstract : INPUT-OUTPUT TABLE parameter support.
+**
+** Copyright (c) 2013-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210430 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.util;
+
+import com.goldencode.p2j.persist.*;
+
+/**
+ * Implements the INPUT-OUTPUT TABLE parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class InputOutputTableParameter
+extends TableParameter
+{
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    */
+   public InputOutputTableParameter(Temporary table)
+   {
+      super(table, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputTableParameter(Temporary table, ParameterOption option)
+   {
+      super(table, option);
+   }
+   
+   /**
+    * Create an instance.
+    *
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    */
+   public InputOutputTableParameter(handle tableHandle)
+   {
+      super(tableHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance.
+    *
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputTableParameter(handle tableHandle, ParameterOption option)
+   {
+      super(tableHandle, option);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    */
+   public InputOutputTableParameter(TableWrapper resultSet)
+   {
+      super(resultSet, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputTableParameter(TableWrapper resultSet, ParameterOption option)
+   {
+      super(resultSet, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   @Override
+   public boolean isInputMode()
+   {
+      return true;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   @Override
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

